/*
 *  Copyright 2001-2010 Mikhail Kryshen <mikhail@kryshen.net>
 *
 *  This file is part of Graph Game.
 *
 *  Graph Game is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  Graph Game is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with Graph Game.  If not, see <http://www.gnu.org/licenses/>.
 */
package kryshen.graphg;

import java.awt.Graphics;
import java.net.URL;

public class Applet extends java.applet.Applet {
    private RenderingManager rm = new RenderingManager();
    private Game game = new Game();
    private boolean loaded = false;
    private boolean loading = false;
    
    public void init() {
        game.setContainer(this);
	game.init();

	String skinParameter = getParameter("skin");
	final String skin = (skinParameter == null) ?
			    "skins/default.bin" : skinParameter;
	
	if (!loaded && !loading) {
	    loading = true;
	    
	    (new Thread() {
		    public void run() {
			try {
			    try {
				game.load((new URL(getCodeBase(), skin))
					  .openStream());
				loaded = true;
			    } catch (Exception e) {
				game.displayError(e);
			    }
			    
			} finally {
			    loading = false;
			}
		    }
		}).start();
	}
    }

    public void destroy() {
	game.destroy();
    }

    public void update(Graphics g) {
	paint(g);
    }

    public void paint(Graphics g) {
	rm.updateBuffer(this, g, getSize());
	game.render(rm.offscreen);
	super.paint(rm.offscreen);
	g.drawImage(rm.buffer, 0, 0, null);
    }
}
